package de.historischekommission_muenchen.oxydition.common.dialogs;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JTextField;

import de.historischekommission_muenchen.oxydition.common.beans.ListSelectionTextfieldBean;

/**
 * Dialogfenster für Operationen, bei denen die Benutzer*innen einen Eintrag aus
 * einer Liste auswählen müssen und außerdem eine Eingabe in einem Textfeld
 * machen können.
 * 
 * @author Maximilian Schrott
 *
 */
public class ListSelectionTextfieldDialog extends ModularListSelectDialog {

	private static final long serialVersionUID = -5898115811654358186L;

	protected JTextField inputField;
	protected String inputFieldLabel;
	private ListSelectionTextfieldBean inputBean;

	// Zwei Konstruktoren: Einer für Operationen, die beide Teillisten der
	// UpdatingJList benutzen und einer für Operationen, die nur eine Teilliste
	// benötigen
	public ListSelectionTextfieldDialog(JFrame owner, String title, String[] eintraege, String[] ids,
			String textfieldLabel) {
		super(owner, title, eintraege, ids);
		inputField = addInputField(textfieldLabel);
	}

	public ListSelectionTextfieldDialog(JFrame owner, String title, String[] eintrage, String textFieldLabel) {
		super(owner, title, eintrage);
		inputField = addInputField(textFieldLabel);
	}

	protected JTextField addInputField(String labelText) {

		return insertTextFieldwithLabel(labelText, additionalInputPanel);
	}

	@Override
	public ListSelectionTextfieldBean displayDialog() {

		okButton.addActionListener(new OkButtonListener());
		inputBean = new ListSelectionTextfieldBean();

		readyDialog();
		return inputBean;
	}

	public void prefillTextfield(String text) {
		inputField.setText(text);
	}

	private class OkButtonListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {

			int selectedIndex = selectionList.getSelectedIndex();

			if (selectedIndex > -1) {

				inputBean.value = selectionList.getSelectedValue();
				inputBean.id = selectionList.getSelectedMetaEntry();
				inputBean.textInput = inputField.getText();
				inputBean.isFilled = true;

				dispose();
			}
		}
	}
}
