package de.historischekommission_muenchen.oxydition.common.dialogs;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFrame;

import de.historischekommission_muenchen.oxydition.common.beans.ListSelectionBean;

/**
 * Dialogfenster für Operationen, die nur eine Auswahlliste brauchen. Enthält
 * nur eine Liste (mit Suchfeld) und die Funktionsabschlussbuttons. Gibt nach
 * erfolgreichem Abschluss der Eingabe die Daten des gewählten Listeneintrags an
 * die aufrufende Klasse zurück.
 * 
 * @author Maximilian Schrott
 *
 */
public class SimpleListSelectionDialog extends ModularListSelectDialog {

	private static final long serialVersionUID = -7125862636157699602L;
	private ListSelectionBean input;

	public SimpleListSelectionDialog(JFrame owner, String title, String[] eintraege, String[] ids) {
		super(owner, title, eintraege, ids);
	}

	public ListSelectionBean displayDialog() {

		input = new ListSelectionBean();
		okButton.addActionListener(new OkButtonListener());

		readyDialog();
		return input;
	}

	private class OkButtonListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
			int selectedIndex = selectionList.getSelectedIndex();

			if (selectedIndex > -1) {

				input.value = selectionList.getSelectedValue();
				input.id = selectionList.getMetaEntryAt(selectedIndex);
				input.isFilled = true;

				dispose();
			}
		}
	}
}
