package de.historischekommission_muenchen.oxydition.common.dialogs.elements;

import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;

/**
 * DocumentListener-Implementierung, die die Eingaben in ein Texteingabeelement
 * überwacht und dementsprechend die Filtermethode einer zugeordneten
 * JOptionList auslöst.
 * 
 * @author Maximilian Schrott
 *
 */
public class SelectionListSearchFieldListener implements DocumentListener {

	private UpdatingJList<String> attachedList;

	/**
	 * 
	 * @param list - Die Liste, die durch die Eingaben ins Textfeld beeinflusst
	 *             werden soll
	 */
	public SelectionListSearchFieldListener(UpdatingJList<String> list) {
		attachedList = list;
	}

	@Override
	public void removeUpdate(DocumentEvent e) {
		try {
			performUpdate(e);
		} catch (BadLocationException e1) {
			e1.printStackTrace();
		}
	}

	@Override
	public void insertUpdate(DocumentEvent e) {
		try {
			performUpdate(e);
		} catch (BadLocationException e1) {
			e1.printStackTrace();
		}
	}

	@Override
	public void changedUpdate(DocumentEvent e) {
		// Nicht benötigt
	}

	private void performUpdate(DocumentEvent e) throws BadLocationException {

		Document input = e.getDocument();
		int inputLength = input.getLength();

		attachedList.updateList(input.getText(0, inputLength));

	}
}
