package de.historischekommission_muenchen.oxydition.common.operations;

import java.io.File;
import java.util.ArrayList;

import de.historischekommission_muenchen.oxydition.common.beans.ListSelectionBean;
import de.historischekommission_muenchen.oxydition.common.utilities.XMLUtility;

/**
 * Spezialisierung von InsertFileReference. Anders als die Überklasse erlaubt
 * diese Operation nur den Verweis auf XML-Dokumente *
 * 
 * @author Maximilian Schrott
 *
 */
public class InsertDocumentFileReference extends InsertFileReference {

	@Override
	// Überschreibt Methode um nur XML-Dateien zuzulassen
	protected ArrayList<File> filterFiles(File[] files) {
		ArrayList<File> fileredFileList = new ArrayList<File>();

		for (int i = 0; i < files.length; i++) {
			File file = files[i];
			String fileName = file.getName();

			if (!file.isDirectory() && !fileName.startsWith(".") && fileName.endsWith(".xml")) {
				fileredFileList.add(file);
			}
		}

		return fileredFileList;
	}

	@Override
	protected String constructReferenceFragment(ListSelectionBean input) {
		StringBuilder referenceBuilder = new StringBuilder();
		String value = XMLUtility.escapeXML(input.value);

		referenceBuilder.append("<ref " + XMLUtility.TEIXMLNS + " type='Dokumentenreferenz' target='" + value + "'/>");

		return referenceBuilder.toString();
	}

}
