package de.historischekommission_muenchen.oxydition.protedition.minrprot.operations;

import javax.swing.JFrame;

import de.historischekommission_muenchen.oxydition.common.utilities.XMLUtility;
import de.historischekommission_muenchen.oxydition.protedition.common.beans.InsertProtocolHeaderBean;
import de.historischekommission_muenchen.oxydition.protedition.common.operations.InsertProtocolHeader;
import de.historischekommission_muenchen.oxydition.protedition.minrprot.dialogs.InsertProtocolHeaderDialog_MinRProt;

/**
 * Oxygen-Author-Operation mit der die Benutzer*innen den Dokumentenkopf eines
 * MinRProt-Protokolls einfügen können. Die hierfür nötigen Daten gibt die
 * Benutzer*innen in einem Dialogfenster ein.
 * 
 * @author Maximilian Schrott
 *
 */
public class InsertProtocolHeader_MinRProt extends InsertProtocolHeader {

	@Override

	public String getDescription() {
		return "Nimmt die Eingaben der Benutzer*innen für die Grunddaten des MinRProt-Protokolls entgegen und konstruiert daraus einen Dokumentenkopf";
	}

	@Override
	protected InsertProtocolHeaderBean getInputData(JFrame parentFrame) {

		InsertProtocolHeaderDialog_MinRProt dlg = new InsertProtocolHeaderDialog_MinRProt(parentFrame);

		InsertProtocolHeaderBean input = dlg.displayDialog();

		return input;
	}

	@Override
	protected String constructProtocolHeaderFragment(InsertProtocolHeaderBean inputBean) {

		StringBuilder fragmentBuilder = new StringBuilder();
		fragmentBuilder.append("<head " + XMLUtility.TEIXMLNS + ">");

		fragmentBuilder.append("<num " + XMLUtility.TEIXMLNS + " n='" + inputBean.protNumWithLeadingZeros + "'>"
				+ inputBean.protNum + "</num>");
		fragmentBuilder.append("<seg " + XMLUtility.TEIXMLNS + " type='Protokolltitel'>" + inputBean.title + "</seg>");
		fragmentBuilder
				.append("<date " + XMLUtility.TEIXMLNS + " when='" + inputBean.normDate + "'>" + inputBean.sourceDate);
		fragmentBuilder.append("<time " + XMLUtility.TEIXMLNS + " type='Beginn' when='" + inputBean.normBegin + ":00'>"
				+ inputBean.sourceBegin + "</time>");
		fragmentBuilder.append("<time " + XMLUtility.TEIXMLNS + " type='Ende' when='" + inputBean.normEnd + ":00'>"
				+ inputBean.sourceEnd + "</time>");
		fragmentBuilder.append("</date></head>");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Anwesend'/>");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Entschuldigt'/>");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Tagesordnung'/>");

		return fragmentBuilder.toString();
	}

}
