package de.historischekommission_muenchen.oxydition.protedition.weimprot.operations;

import javax.swing.JFrame;

import de.historischekommission_muenchen.oxydition.common.utilities.XMLUtility;
import de.historischekommission_muenchen.oxydition.protedition.common.beans.InsertProtocolHeaderBean;
import de.historischekommission_muenchen.oxydition.protedition.common.operations.InsertProtocolHeader;
import de.historischekommission_muenchen.oxydition.protedition.weimprot.dialogs.InsertProtocolHeaderDialog_WeiMProt;

/**
 * Oxygen-Author-Operation mit der die Benutzer*innen den Dokumentenkopf eines
 * WeiMProt-Protokolls einfügen können. Die hierfür nötigen Daten gibt die
 * Benutzer*innen in einem Dialogfenster ein.
 * 
 * @author Maximilian Schrott
 *
 */
public class InsertProtocolHeader_WeiMProt extends InsertProtocolHeader {

	@Override
	protected InsertProtocolHeaderBean getInputData(JFrame parentFrame) {

		InsertProtocolHeaderDialog_WeiMProt dlg = new InsertProtocolHeaderDialog_WeiMProt(parentFrame);

		InsertProtocolHeaderBean input = dlg.displayDialog();

		return input;
	}

	@Override
	protected String constructProtocolHeaderFragment(InsertProtocolHeaderBean input) {

		StringBuilder fragmentBuilder = new StringBuilder();
		fragmentBuilder.append("<head " + XMLUtility.TEIXMLNS + ">");

		fragmentBuilder.append("<num " + XMLUtility.TEIXMLNS + " n='" + input.protNumWithLeadingZeros + "'>"
				+ input.protNum + "</num>");
		fragmentBuilder.append("<seg " + XMLUtility.TEIXMLNS + " type='Protokolltitel'>" + input.title + "</seg>");

		fragmentBuilder.append("<seg " + XMLUtility.TEIXMLNS + " type='Raumzeit'>");

		fragmentBuilder.append("<seg " + XMLUtility.TEIXMLNS + " type='Sitzungsort'>" + input.place + "</seg>, ");

		fragmentBuilder.append("<date " + XMLUtility.TEIXMLNS + " when='" + input.normDate + "'>" + input.sourceDate);

		fragmentBuilder.append(constructTimeFragment(input));

		fragmentBuilder.append("</date> </seg> </head> ");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Anwesend'/>");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Protokollführer'/>");
		fragmentBuilder.append("<div " + XMLUtility.TEIXMLNS + " type='Tagesordnung'/>");

		return fragmentBuilder.toString();

	}

	// Beginn- und Endzeitpunkt sind optional. Es müssen aber immer beide
	// zusammengehörigen Felder ausgefüllt sein, damit die Eingabe gültig ist
	private Object constructTimeFragment(InsertProtocolHeaderBean input) {

		StringBuilder timeBuilder = new StringBuilder();

		if (input.sourceBegin.length() == 0 && input.sourceEnd.length() == 0) {
			timeBuilder.append("<seg " + XMLUtility.TEIXMLNS
					+ " type='Zeitinformation'>keine Angaben zu Beginn und Ende der Sitzung</seg>");
		} else {

			if (input.sourceBegin.length() != 0) {
				timeBuilder.append("<time " + XMLUtility.TEIXMLNS + " type='Beginn' when='" + input.normBegin + ":00'>"
						+ input.sourceBegin + "</time>");
			}

			if (input.sourceEnd.length() != 0) {
				timeBuilder.append("<time " + XMLUtility.TEIXMLNS + " type='Ende' when='" + input.normEnd + ":00'>"
						+ input.sourceEnd + "</time>");
			}
		}
		return timeBuilder;
	}

}
