package de.historischekommission_muenchen.oxydition.register.adaptions.delbrf;

import javax.swing.text.BadLocationException;

import de.historischekommission_muenchen.oxydition.common.utilities.XMLUtility;
import de.historischekommission_muenchen.oxydition.register.operations.RegisterInsertPersonQuickReference;
import ro.sync.ecss.extensions.api.node.AuthorElement;

/**
 * Anpassung der Operation zum automatischen Erstellen und Einfügen einer
 * Personenkurzreferenz für die Personenregisterdatenbank der Delbrück-Edition
 * 
 * @author Maximilian Schrott
 *
 */
public class RegisterInsertPersonQuickReference_DelBrf extends RegisterInsertPersonQuickReference {

	@Override
	protected String constructQuickReferenceFragment(AuthorElement personNode) throws BadLocationException {

		String nameText = XMLUtility.getChildText(personNode, "persName", "Lesename");
		nameText = XMLUtility.escapeXML(nameText);
		String qualificatorText = XMLUtility.getChildText(personNode, "note", "Qualifikator");
		qualificatorText = XMLUtility.escapeXML(qualificatorText);
		String birthText = XMLUtility.getChildText(personNode, "birth");
		birthText = XMLUtility.escapeXML(birthText);
		String deathText = XMLUtility.getChildText(personNode, "death");
		deathText = XMLUtility.escapeXML(deathText);

		StringBuilder fragmentBuilder = new StringBuilder();
		fragmentBuilder.append(nameText);
		if (birthText.length() > 0 || deathText.length() > 0) {
			fragmentBuilder.append(" (" + birthText + "-" + deathText + ")");
		}

		if (qualificatorText.length() > 0) {
			fragmentBuilder.append(": " + qualificatorText);
		}

		fragmentBuilder.append(".");

		return fragmentBuilder.toString();
	}
}
