package de.historischekommission_muenchen.oxydition.register.adaptions.minrprot;

import javax.swing.text.BadLocationException;

import de.historischekommission_muenchen.oxydition.common.utilities.XMLUtility;
import de.historischekommission_muenchen.oxydition.register.operations.RegisterInsertPersonQuickReference;
import ro.sync.ecss.extensions.api.node.AuthorElement;

/**
 * Anpassung der Operation zum Erstellen eines Biogrammrumpfs für die Edition
 * MinRProt. Verändert den Aufbau der Biogrammrumpfs gegenüber der
 * Standartoperation.
 * 
 * @author Maximilian Schrott
 * 
 */
public class RegisterInsertQuickReference_MinRProt extends RegisterInsertPersonQuickReference {

	@Override
	protected String constructQuickReferenceFragment(AuthorElement personNode) throws BadLocationException {

		String nameText = XMLUtility.getChildText(personNode, "persName", "Lesename");
		String birthText = XMLUtility.getChildText(personNode, "birth");
		String deathText = XMLUtility.getChildText(personNode, "death");
		String qualificatorText = XMLUtility.getChildText(personNode, "note", "Qualifikator");

		StringBuilder fragmentBuilder = new StringBuilder();
		fragmentBuilder.append(nameText);
		if (birthText.length() > 0 || deathText.length() > 0) {
			fragmentBuilder.append(" (" + birthText + "-" + deathText + ")");
		}
		if (qualificatorText.length() > 0) {
			fragmentBuilder.append(", " + qualificatorText);
		}

		return fragmentBuilder.toString();
	}
}
