package de.historischekommission_muenchen.oxydition.register.beans;

import java.util.ArrayList;

import de.historischekommission_muenchen.oxydition.common.beans.OperationInputBean;

/**
 * Datenhaltungsobjekt zum Speichern der Daten eines bestehenden oder neu
 * anzulegenen Eintrags aus der Sachschlagworts-RDB
 * 
 * @author Maximilian Schrott
 *
 */

public class RegisterKeywordBean extends OperationInputBean {

	public String id;
	public String keywordTerm;
	private ArrayList<String[]> keywordCrossReferences = new ArrayList<String[]>();

	public RegisterKeywordBean() {
	}

	// Kopier-Konstruktor
	public RegisterKeywordBean(RegisterKeywordBean copyBean) {
		this.id = copyBean.id;
		this.keywordTerm = copyBean.keywordTerm;
		setKeywordCrossReferences(copyBean.keywordCrossReferences);
	}

	public void setKeywordCrossReferences(ArrayList<String[]> referenceList) {
		keywordCrossReferences = referenceList;
	}

	public void addKeywordCrossReference(String term, String id) {

		if (!crossReferenceAlreadySet(term)) {

			String[] newCrossReference = { term, id };

			keywordCrossReferences.add(newCrossReference);
		}
	}

	public void removeKeywordCrossReference(String term) {

		int removeIndex = findCrossReferenceIndex(term);

		if (removeIndex >= 0) {
			keywordCrossReferences.remove(removeIndex);
		}
	}

	public String getCrossReferenceTerm(int index) {

		return keywordCrossReferences.get(index)[0];
	}

	public String getCrossReferenceId(int index) {

		return keywordCrossReferences.get(index)[1];
	}

	public int getKeywordCrossReferenceSize() {
		return keywordCrossReferences.size();
	}

	private int findCrossReferenceIndex(String term) {
		int removeIndex = -1;

		for (int i = 0; i < keywordCrossReferences.size(); i++) {

			String checkCrossReferenceTerm = getCrossReferenceTerm(i);

			if (checkCrossReferenceTerm.equalsIgnoreCase(term)) {
				removeIndex = i;
			}
		}
		return removeIndex;
	}

	public boolean crossReferenceAlreadySet(String term) {

		if (findCrossReferenceIndex(term) >= 0) {
			return true;
		} else {
			return false;
		}

	}

}
