package de.historischekommission_muenchen.oxydition.register.dialogs;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JTextField;

import de.historischekommission_muenchen.oxydition.common.dialogs.ModularGridBagDialog;
import de.historischekommission_muenchen.oxydition.register.beans.NewSourceCollectionBean;

/**
 * Dialogfenster für die Operation zum Einfügen neuer Archiveeinträge ins
 * Register der ungedruckten Quellen.
 * 
 * @author Maximilian Schrott
 *
 */
public class RegisterNewSourceArchiveDialog extends ModularGridBagDialog {

	private static final long serialVersionUID = 8034689043028088273L;

	NewSourceCollectionBean input;
	JTextField normNameField;
	JTextField fullNameField;

	public RegisterNewSourceArchiveDialog(JFrame owner) {

		super(owner, "Neues Archiv zu Register hinzufügen");

		normNameField = addField("Kennname (Abkürzung falls vorhanden)");
		fullNameField = addField("Voller Name (nur notwendig wenn nicht gleichzeitig Kenname)");

		insertOperationEndButtonPanel("Einfügen", "Abbrechen");

	}

	public NewSourceCollectionBean displayDialog() {

		okButton.addActionListener(new OkButtonListener());
		input = new NewSourceCollectionBean();

		readyDialog();
		return input;

	}

	private class OkButtonListener implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {

			String normNameText = normNameField.getText();
			String fullNameText = fullNameField.getText();
			if (normNameText.isEmpty()) {
				displayInputNotAllValidMessage("Es wurde kein Wert für Kennname eingegeben");
			} else {
				input.normName = normNameText;
				input.fullName = fullNameText;
				input.isFilled = true;

				dispose();
			}

		}
	}

}
